/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "project.h"
#include "define.h"
#include "isr.h"
#include "motor_ctrl.h"
#include "chip_init.h"
#include "speed_set.h"
#include "interface.h"
#include "stdlib.h"

//CY_ISR_PROTO(Ibus_Over_ISR);
//CY_ISR_PROTO(AD_Time_ISR);
//CY_ISR_PROTO(FOC_MainLoop_ISR);

int main(void)
{
	/*====================================================================*
	* motor initialization                                               *
	*====================================================================*/
    /* Opamp Init */
	//Opamp_A_Start();
	//Opamp_B_Start();
	
	/* SAR ADC Init */
	Adc_Start();
	
    /* TCPWM Init */
    PWM_Start();
    
    /* SPI Init */
    SPI_Start();
    
    SPI_Start();
    
    /* Encoder start */
    Encoder_Start();
    
    /* Motor Parameters Init */
	MotorCtrl_Init(Motor_u16CarrierFreq);
    /* ADC ISR Init    */
 //ADC_IRQ_StartEx(AD_Time_ISR);
	/* PWM Main ISR Init    */
 //PWM_MainLoop_ISR_StartEx(FOC_MainLoop_ISR);

	/*====================================================================*
     * protection initialization                                          *
     *====================================================================*/
	/* Lpcomp and IDAC Init For Bus Current Protection */
	LPComp_Start();
	IDAC_IbusPt_Start();
	IDAC_IbusPt_SetValue(0xFF);//0xC2
	
    //isr_Ibus_Over_StartEx(Ibus_Over_ISR);
    
	/*UART Init*/ 
	UART_BCP_Start();     
    
    /* delay for a while to make DCbus voltage stable, otherwise it triggers under voltage fault */
    CyDelay(100);
    
	/* Enable global interrupts. */
    //CyGlobalIntEnable;  
    __enable_irq();
	
    while(1)
    {
        
		if ((MotorCtrl_stcRunPar.u8Status == 0) &&
		    (MotorCtrl_stcRunPar.u32ErroType == 0))
		{            
		    if(Running)
		    {
	            MotorCtrl_Start(Motor_u16CarrierFreq); 
		    }
		}

		if(MotorCtrl_stcRunPar.u8Status == 1)
		{
		    if(MotorCtrl_stcRunPar.u32ErroType != 0||Running == 0) //MotorCtrl_stcRunPar.i32TargetSpeedRpm
		    {
		        MotorCtrl_Stop(); 
                Encoder_Stop();
		    }
		} 

		///////////////////set speed///////////////////////
		if(Motor_u8SpeedSetEn == 1)
		{
			AD_Speed();
		}
		//////////////////////run direction and LED/////////////
		Peripheral_Function();
		////////only send data out when motor is running //////////
		if(!Running)//MotorCtrl_stcRunPar.u8Status == 1)
		{				
            //Pin_Debug_Write(0x01);
			BCPPoll();			
            //Pin_Debug_Write(0x00);
		}
        //Pin_Debug_Write(0x01);
        BCPRead();
        //Pin_Debug_Write(0x00);

	}
}
